#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <shlwapi.h>
HANDLE hStdOut;
HDC ic;

int con_out(char *s, int len) {
 DWORD b;
 if ((DWORD)hStdOut<32) CharToOemBuff(s,s,len);
 WriteFile(hStdOut,s,len,&b,NULL);
 return (int)b;
}

int vprintf(const char *format, va_list args) {
 char buf[1024];
 return con_out(buf,wvnsprintf(buf,sizeof(buf),format,args));
}

int printf(const char *format, ...) {
 va_list args;
 va_start(args,format);
 int ret=vprintf(format,args);
 va_end(args);
 return ret;
}

void OutWidths(const char *FontName) {
 HFONT font=CreateFont(96,0,0,0,0,0,0,0,0,0,0,0,0,FontName);
 HFONT ofont=SelectFont(ic,font);
 SIZE sz;
 GetTextExtentPoint(ic,"A",1,&sz);
 printf("Fontname: %s, Fontgre: 96, Offset: 32, Hhe: %d\r\n\"",FontName,sz.cy);
 int min=255,max=0;
 for (char c=' '; c; c++) {
  GetTextExtentPoint(ic,&c,1,&sz);
  printf("%c",sz.cx+32);
  if (min>sz.cx) min=sz.cx;
  if (max<sz.cx) max=sz.cx;
 }
 SelectFont(ic,ofont);
 printf("\"\r\nMinimum: %d, Maximum: %d\r\n\r\n",min,max);
}

extern "C" int CALLBACK mainCRTStartup(void) {
 hStdOut=GetStdHandle(STD_OUTPUT_HANDLE);
 ic=CreateIC("DISPLAY",NULL,NULL,NULL);
 OutWidths("Courier New");
 OutWidths("Arial");
 OutWidths("Times New Roman");
 DeleteDC(ic);
 return 0;
}
